/********************************************************************/
/*                                                                  */
/*  Licensed Materials - Property of IBM.                           */
/*  5724-T42                                                        */
/*  5724-T43                                                        */
/*  Copyright IBM Corp. 2008.                                       */
/*  All Rights Reserved.                                            */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication or disclosure restricted by                    */
/*  GSA ADP Schedule Contract with IBM Corp.                        */
/*                                                                  */
/*  This file contains sample code.  You may copy, modify, and      */
/*  distribute these samples, or their modifications, in any        */
/*  form, internally or as part of Your application or related      */
/*  documentation. These samples have not been tested under all     */
/*  conditions and are provided to You by IBM without obligation    */
/*  of support of any kind. IBM PROVIDES THESE SAMPLES "AS IS"      */
/*  SUBJECT TO ANY STATUTORY WARRANTIES THAT CANNOT BE EXCLUDED.    */
/*  IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS OR        */
/*  IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES   */
/*  OR CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR      */
/*  PURPOSE, AND NON-INFRINGEMENT REGARDING THESE SAMPLES OR        */
/*  TECHNICAL SUPPORT, IF ANY. You will indemnify IBM or third      */
/*  parties that provide IBM products ("Third Parties") from and    */
/*  against any third party claim arising out of the use,           */
/*  modification or distribution of these samples with Your         */
/*  application. You may not use the same path name as the          */
/*  original files/modules. You must not alter or delete any        */
/*  copyright information in the Samples.                           */
/*                                                                  */
/********************************************************************/
/********************************************************************/
/*                                                                  */
/* DESCRIPTION:                                                     */
/*    This source file is the implementation of a SPU user-defined  */
/*    function that can be used to add two 2D arrays in a parallel  */
/*    region.                                                       */
/*                                                                  */
/********************************************************************/

#include <spu_intrinsics.h>

void spu_sum_array(__ea int *data1, __ea int *data2, __ea int *result, int size) {
	__ea vector signed int *op1 = (__ea vector signed int*) data1;
	__ea vector signed int *op2 = (__ea vector signed int*) data2;
	__ea vector signed int *res = (__ea vector signed int*) result;

        int i;

	for (i = 0; i < size/4; i++) {
		res[i] = spu_add(op1[i], op2[i]);
	}
}
